package leelib.util
{
	import flash.utils.getTimer;

	public class Out
	{
		public static const SHOW_DEBUG:uint = 4;
		public static const SHOW_INFO:uint = 3;
		public static const SHOW_WARNING:uint = 2;
		public static const SHOW_ERROR:uint = 1;
		public static const SHOW_NONE:uint = 0;
		
		public static const TIMESTAMPTYPE_NONE:uint = 0;
		public static const TIMESTAMPTYPE_DATE:uint = 1;
		public static const TIMESTAMPTYPE_GETTIMER:uint = 2;
		
		private static var _level:uint = SHOW_DEBUG;
		private static var _timeStampType:uint = TIMESTAMPTYPE_GETTIMER;
		
		public static function get level():uint
		{
			return _level;
		}
		public static function set level($u:uint):void
		{
			_level = $u;
			
			var a:Array = ['NONE', 'ERROR', 'WARNING', 'INFO', 'DEBUG (ALL)'];
			trace('[Out level set to: ' + a[_level] + ']');
		}

		public static function get timeStampType():uint
		{
			return _timeStampType;
		}
		public static function set timeStampType($u:uint):void
		{
			_timeStampType = $u;
		}
		
		public static function d(...$rest):void
		{
			if (_level >= SHOW_DEBUG) { 
				trace("[Out.d" + timeStamp() + "]");
				trace($rest);
			}
		}
		
		public static function i(...$rest):void
		{
			if (_level >= SHOW_INFO) {
				trace("[Out.i" + timeStamp() + "]");
				trace($rest);
			}
		}
		
		public static function w(...$rest):void
		{
			if (_level >= SHOW_WARNING) { 
			trace("[Out.w" + timeStamp() + "]");
			trace($rest);
			}
		}

		public static function e(...$rest):void
		{
			if (_level >= SHOW_ERROR) {
				trace("[Out.ERROR" + timeStamp() + "]");
				trace($rest);
			}
		}
		
		private static function timeStamp():String
		{
			switch (_timeStampType)
			{
				case TIMESTAMPTYPE_NONE:
					return "";
				case TIMESTAMPTYPE_DATE:
					return " " + new Date().toString();
				case TIMESTAMPTYPE_GETTIMER:
					return " " + (getTimer()/1000).toString();
			}
			return "";
		}
	}
}